import {
  geoPath,
  geoNaturalEarth1,
  zoom,event
} from 'd3';

const projection =geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

export const choroplethMap = (selection,props) => { //vyselekt.svg a properties ako v react
    const {
       features,
       colorScale,
       colorValue,
       selectedColorValue
    }=props;
  
  const gUpdate=selection.selectAll('g').data([null]);
  
  const gEnter = gUpdate.enter().append('g'); //group element containig sphere and counties
  const g = gUpdate.merge(gEnter);
   gEnter.append('path')
           .attr('class','sphere')
           .attr('d',pathGenerator({type:'Sphere'}))
        .merge(gUpdate.select('.sphere'))
              .attr('opacity', selectedColorValue ? 0.1 : 0.7);
            //.attr('opacity', 0.1)
 
  ;
    
  selection.call(zoom().on('zoom',()=>{
          g.attr('transform',event.transform);
            console.log('zooming');
      }));         
      
 // const colorScale=scaleOrdinal(schemeCategory10);
     const countryPaths=  g.selectAll('.country')
     	.data(features);
    const countryPathsEnter= countryPaths
         .enter().append('path')
          .attr('class','country');
       
  countryPaths
        .merge(countryPathsEnter)//tieto hodnoty sa menia invokaciam
          .attr('d',pathGenerator)//tieto hodnoty sa nemenia medzi invokaciami
           .attr('fill',d=>colorScale(colorValue(d)))
        .attr('opacity',d=>(colorValue(d)===selectedColorValue||!selectedColorValue)//d=> je to input a jedna sa o country
             ? 1
             :0.2
             
             ) 
        .classed('highlighted',d => selectedColorValue &&colorValue(d)===selectedColorValue)
  ;
       
  countryPathsEnter
            .append('title')
              .text(d=>d.properties.name+" : "+colorValue(d));
  
}