import {getCars} from './getCars';
import {colorLegend} from './colorLegend';

import {generateReport} from './generateReport';
import {loadAndProcessData} from './loadAndProcessData';
import {choroplethMap} from './choroplethMap';

import {select,event,scaleOrdinal,schemeCategory10,schemeSpectral} from 'd3';


 const svg=select('svg');
 const colorScale=scaleOrdinal();


 
 const g=svg.append('g');
      svg.style('background-color','white');
 const choroplethmapG=svg.append('g');
 const colorLegendG=svg.append('g')
          .attr('transform',`translate(50,250)`);



 
  const colorValue =d=>d.properties.income_grp;
  let selectedColorValue;//state, ktory mozeme menit
  let features;

  const onClick = d =>{
   selectedColorValue=d;
    render();
  };

   const render = () => {//should render colorlegend and also map
       colorScale
         .domain(features.map(colorValue))//ordered
         .domain(colorScale.domain().sort().reverse())
          .range(schemeSpectral[colorScale.domain().length]);
     
     colorLegendG.call(colorLegend,{
           colorScale,
           circleRadius:15,
           spacing:35,
           textOffset:20,
           backgroundRectWidth:350,
           onClick,
           selectedColorValue
           });
     
     choroplethmapG.call(choroplethMap,{
           features,
           colorScale,
           colorValue,
           selectedColorValue
           });

   
   };

   loadAndProcessData().then(countries=> {  
     features=countries.features;
      render();
  } );

 
 /*

  json('https://unpkg.com/world-atlas@1.1.4/world/110m.json')
     .then(data => {//it is a promise
    
	});


   */ 
		
























getCars().then(cars => {
  const message2 = generateReport(cars,3000);
document.getElementById("message2").textContent=message2; 
});




