import { feature } from 'topojson'; //potrebujem transformovat topojson na geojson s kt. pracuje d3.js
import { tsv, json } from 'd3';

export const loadAndProcessData = () =>
  Promise.all([
    // for coupling premises into one scope
    tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
    json('https://unpkg.com/world-atlas@1.1.4/world/50m.json'),
    tsv('cities.tsv'),
  ]).then(([tsvData, topoJSONdata, tsvcities]) => {
    // console.log(data);
    const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

    const rowById = tsvData.reduce((accumulator, d) => {
      // accumulator[d.iso_n3]=d.name;//iba name
      accumulator[d.iso_n3] = d; //vsetko
      return accumulator;
    }, {});

    countries.features.forEach((d) => {
      // urobime preprocesing, aby sme nemuseli robit lookup neskor
      Object.assign(d.properties, rowById[d.id]); //namiesto rowById[].name budeme vola d.name...
    });
    //console.log(countries);
    return countries;
  });
